



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>c++ primer读书笔记之c++11（四）</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">c++ primer读书笔记之c++11（四）</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-01 04:57:04 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h3>1 &nbsp;带有作用域的枚举 scoped-enumeration</h3>
<p>相信大家都用过枚举量，都是不带有作用域的，在头文件中定义需要特别注意不要出现重名的情况。为了解决这种问题，c++11提供了带作用于的枚举。可以使用class EnumName定义，示例代码如下：</p>
<div>
<pre class="prettyprint linenums">enum {ZERO, ONE, TWO};<br />
enum class color {RED, BLUE, GREEN};</pre>
</div>
<p>上面的是没有作用域的枚举定义形式，下面是带有作用域的枚举定义形式，调用带有作用域的枚举必须指定作用域，否则会编译出错。</p>
<p>还有一个比较大的区别就是，带有作用域的枚举量不能自动转换为int类型，而没有作用域的枚举量是可以的。</p>
<h3>2 枚举的长度和前向声明</h3>
<p>c++11针对枚举类型提供了声明枚举类型占用字节长度的机制，可在枚举名之后加上类型限定，代码如下：</p>
<div>
<pre class="prettyprint linenums">enum CtrlType: unsigned long long<br />
{CT_0, CT_1};</pre>
</div>
<p>同时，c++11提供了枚举的前向声明机制。如下代码：</p>
<div>
<pre class="prettyprint linenums">// enum forward declaration<br />
enum InitValues: long long; // unscoped, must specify a size<br />
enum class NewColor; // default int</pre>
</div>
<h3>3 嵌套类、内部类的定义</h3>
<p>这个部分不是c++11新加的内容，只是个人感觉比较有趣和可用的定义形式。内部类的可以仅在外部类中声明，而不需要直接给出定义式。示例代码如下：</p>
<div>
<pre class="prettyprint linenums">// nested class<br />
class OuterClass<br />
{<br />
    class InnerClass;<br />
};

class OuterClass::InnerClass<br />
{

};</pre>
</div>
<p>外部类OutClass有点像命名空间的性质了。</p>
<h3>4 共用体支持包含带有构造函数的类成员</h3>
<p>有时候使用union，会存在一个比较大的限制，所有的union成员必须没有构造函数，因为共用体不知道如何初始化和反初始化。</p>
<p>在c++11中允许union定义包含带有构造函数的成员，代码如下：</p>
<div>
<pre class="prettyprint linenums">// union with class member<br />
union UnionTest<br />
{<br />
    int a;<br />
    std::string str;<br />
};</pre>
</div>
<p>但是在使用的时候，我们必须维护union中的数据有效性，编译器依然不知道如何构造和析构union中的变量。慎用!!</p>
<h3>5 标准库中添加tuple、支持正则表达式、支持新的随机数生成机制</h3>
<p>tuple是对pair的扩展，支持任意数目任意类型的多元组。多数用于多个数据合成一个元素，但是又不想定义新的结构体或类的情况下。具体tuple的用于建议参考：<a href="http://www.cplusplus.com/reference/tuple/" rel="external nofollow noreferrer">http://www.cplusplus.com/reference/tuple/</a>。</p>
<p>c++11中STL引入了随机数生成器（random-number engine）和随机数分配类（random-number distribution class），二者配合可以生成指定范围、指定类型、指定分布的随机数。</p>
<p>由于正则表达式，本人不是很熟悉，这里不做介绍了。有兴趣的可以阅读下c++ primer ch 17.3或者c++11标准。</p>
<h3>附加说明</h3>
<p>本文内容主要是关于 c++ primer 第五版的第16章到第19章中涉及c++11内容的整理。涉及枚举、共用体、嵌套类的新的用法。</p>
<p>所有代码都在gcc v4.8.1的版本中编译测试过，相关源码可以从我的<a href="https://git.oschina.net/Tocy/SampleCode.git" rel="external nofollow noreferrer">git</a>下载，url如下：https://git.oschina.net/Tocy/SampleCode.git，位于c++11目录下的cpp_primer_test4.cpp文件中。</p>
<p>根据其他资料介绍，c++11也支持线程机制，可惜c++ primer中没有介绍。后续可以参考下其他资料继续完善下。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/390e5ooq.html">Bootstrap&amp;lt&semi;基础三&amp;gt&semi; 排版</a>
		</li>
						<li><a href="https://www.batexi.com/a/xq4d3kjq.html">常用的CentOS 7系统yum源集合</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8o3r158.html">在Nifi 里 把 HDFS Json 为csv 格式</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqvpm4yq.html">【原】iOS学习之Swift之语法2&lpar;精简版&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9p5xmk8.html">Java封装</a>
		</li>
						<li><a href="https://www.batexi.com/a/r8m5mw0q.html">ruby formatting time</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j0zwywq.html">Android 编程下去除 ListView 上下边界蓝色或黄色阴影</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyd572mq.html">IIS下PHP的三种配置方式比较</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wy5voq.html">SaaS系列介绍之四：我国SaaS市场发展</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwdxr6l8.html">Shape 与 InlineShape 的区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e17nkz9.html">Ice&lowbar;cream&rsquo;s world III--2122</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mn5e02q.html">SQL SERVER 数据库邮件配置</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rd2lx48.html">php微信接口验证写法</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4yov13q.html">MVC bundles</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j05prwq.html">错误记录--更改tomcat端口号方法，Several ports &lpar;8005&comma; 8080&comma; 8009&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zorp0nq.html">shc加密shell脚本</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zo0myvq.html">写书好累 &amp;lt&semi;HTTP抓包实战&amp;gt&semi;终于出版</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kj213j9.html">七、Sql Server 基础培训《进度7-笛卡尔积（知识点&plus;实际操作）》</a>
		</li>
						<li><a href="https://www.batexi.com/a/93w1wv0q.html">前端和后端的数据交互&lpar;jquery ajax&plus;python flask&plus;mysql&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e4vvge9.html">lch 儿童围棋课堂 初级篇1 &lpar; &lpar;李昌镐 著&rpar;&rpar;</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/93pwv3n8.html">从html加载json文件想起</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnnvy3gq.html">理解metrics&period;classification&lowbar;report</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnnvwnkq.html">MATLAB 向量</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gpjgr49.html">iOS应用间相互跳转</a>
			</li>
						<li><a href="https://www.batexi.com/a/qve2j1y9.html">Zabbix触发器支持的函数说明</a>
			</li>
						<li><a href="https://www.batexi.com/a/9ppw21d9.html">【JQuery】jQuery中的常用方法小结</a>
			</li>
						<li><a href="https://www.batexi.com/a/9630gz49.html">Bitnami Redmine 中文附件名 报错修复</a>
			</li>
						<li><a href="https://www.batexi.com/a/qve2ozy9.html">MySQL经常使用技巧</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zky2j18.html">Android HttpURLConnection源代码分析</a>
			</li>
						<li><a href="https://www.batexi.com/a/8o41w51q.html">【LeetCode-面试算法经典-Java实现】【059-Spiral Matrix II（螺旋矩阵II）】</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
